Subject: powerpc: Incorrect stw operand modifier in __set_pte_at

From: Mathieu Desnoyers <[email-masked]>
Date: Wed, 8 Jul 2020 10:45:13 -0400 (EDT)

Hi,

Reviewing use of the patterns "Un%Xn" with lwz and stw instructions
(where n should be the operand number) within the Linux kernel led
me to spot those 2 weird cases:

arch/powerpc/include/asm/nohash/pgtable.h:__set_pte_at()

                __asm__ __volatile__("\
                        stw%U0%X0 %2,%0\n\
                        eieio\n\
                        stw%U0%X0 %L2,%1"
                : "=m" (*ptep), "=m" (*((unsigned char *)ptep+4))
                : "r" (pte) : "memory");

I would have expected the stw to be:

                        stw%U1%X1 %L2,%1"

and:
arch/powerpc/include/asm/book3s/32/pgtable.h:__set_pte_at()

        __asm__ __volatile__("\
                stw%U0%X0 %2,%0\n\
                eieio\n\
                stw%U0%X0 %L2,%1"
        : "=m" (*ptep), "=m" (*((unsigned char *)ptep+4))
        : "r" (pte) : "memory");

where I would have expected:

                stw%U1%X1 %L2,%1"

Is it a bug or am I missing something ?

Thanks,

Mathieu

-- 
Mathieu Desnoyers
EfficiOS Inc.
http://www.efficios.com